



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>linq之延迟加载和即时加载+标准查询运算符</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">linq之延迟加载和即时加载+标准查询运算符</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 06:11:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Order By操作</h2>
<p><strong>适用场景</strong>：对查询出的语句进行排序，比如按时间排序等等。</p>
<p><strong>说明</strong>：按指定表达式对集合排序；延迟，：按指定表达式对集合排序；延迟，默认是升序，加上descending表示降序，对应的扩展方法是OrderBy和OrderByDescending</p>
<h2>1.简单形式</h2>
<p>这个例子使用 orderby 按雇用日期对雇员进行排序：</p>
<div>
<pre class="prettyprint linenums">var q = from e in db.Employees<br />
        orderby e.HireDate<br />
        select e;
</pre>
</div>
<p>　　</p>
<p>说明：默认为升序</p>
<h2>2.带条件形式</h2>
<p>注意：Where和Order By的顺序并不重要。而在T-SQL中，Where和Order By有严格的位置限制。</p>
<div>
<pre class="prettyprint linenums">var q =<br />
    from o in db.Orders<br />
    where o.ShipCity == "London"<br />
    orderby o.Freight<br />
    select o;
</pre>
</div>
<p>　　</p>
<p>语句描述：使用where和orderby按运费进行排序。</p>
<h2>3.降序排序</h2>
<div>
<pre class="prettyprint linenums">var q =<br />
    from p in db.Products<br />
    orderby p.UnitPrice descending<br />
    select p;
</pre>
</div>
<p>　　</p>
<h2>4.ThenBy</h2>
<p>语句描述：使用复合的 orderby 对客户进行排序，进行排序：</p>
<div>
<pre class="prettyprint linenums">var q =<br />
    from c in db.Customers<br />
    orderby c.City, c.ContactName<br />
    select c;
</pre>
</div>
<p>　　</p>
<p>说明：按多个表达式进行排序，例如先按City排序，当City相同时，按ContactName排序。这一句用Lambda表达式像这样写：</p>
<div>
<pre class="prettyprint linenums">var q =<br />
    .OrderBy(c =&gt; c.City)<br />
    .ThenBy(c =&gt; c.ContactName).ToList();
</pre>
</div>
<p>　　</p>
<p>在T-SQL中没有ThenBy语句，其依然翻译为OrderBy，所以也可以用下面语句来表达：</p>
<div>
<pre class="prettyprint linenums">var q =<br />
    db.Customers<br />
    .OrderBy(c =&gt; c.ContactName)<br />
    .OrderBy(c =&gt; c.City).ToList();
</pre>
</div>
<p>　　</p>
<p>所要注意的是，多个OrderBy操作时，级连方式是按逆序。对于降序的，用相应的降序操作符替换即可。</p>
<div>
<pre class="prettyprint linenums">var q =<br />
    db.Customers<br />
    .OrderByDescending(c =&gt; c.City)<br />
    .ThenByDescending(c =&gt; c.ContactName).ToList();
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx22ev8.html">视图xsl定制之嵌入服务器控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx51vv8.html">（转）WCF开发框架形成之旅---WCF的几种寄宿方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qylx128.html">ccs3中icon转换为字体的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/3900o449.html">&lbrack;IBM DB2&rsqb; db2 terminate 和 db2 connect reset 有什么区别&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kwnkj8.html">Bellman-Ford算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmpr279.html">Winform开发几个常用的开发经验及知识积累（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mn5jgq.html">F&period; Igor and Interesting Numbers</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5gm08.html">HDU5093&mdash;&mdash;Battle ships&lpar;最大二分匹配&rpar;&lpar;2014上海邀请赛重现&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x3g409.html">CentOS6&period;6图文详细安装教程&lpar;有些设置大部分教程没出现过&comma;附带网络设置等&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdxpvl8.html">PC-经典之&OpenCurlyDoubleQuote;运行里面的密密&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o1znn9.html">opencv如何截取子图像</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvg6jjq.html">The introduction to Web&period;config of ASP&period;NET &num;Reprinted&num;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj7mwxq.html">Python知识目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2mr0oq.html">ImageWatch 无法安装在VS2017环境下的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvoklr8.html">三、xadmin----内置插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r52lldq.html">uva-11324-SCC&plus;dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k5rxxq.html">lua -- string</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjjzpr8.html">关于Unity中场景的导入与导出&lpar;专题九&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pldk08.html">java面试第十七天</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn2wjmq.html">&period;NET 知识点总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9geg6r48.html">&lbrack;js高手之路&rsqb; es6系列教程 - 函数的默认参数详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjwp3y8.html">NOIP 2000 提高组 题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1km2yq.html">suffix tree</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp2x239.html">linux守护进程、SIGHUP与nohup详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjw32r8.html">统计s&equals;&amp;quot&semi;hello alex alex hello haiyan cc  haiyan  com&amp;quot&semi;中每个单词的个数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geglxe8.html">js的点表示法和方括号表示法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzly4w8.html">How to quickly become effective when joining a new company</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gez1108.html">CSS选择器大汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey3eje9.html">【Centos7】卸载OpenJDK</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo6gl1q.html">【Linux SELinux】提升系统安全（一）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
